gladeXMLAutoconnect <-
function(xml, f = gladeXMLDefaultConnect, name = character(0))
{
  gtkCheckInherits(xml, "GladeXML")
  if(!is.function(f))
    stop("Need a function for connecting the signals")
  
  invisible(.Call("R_glade_xml_signal_autoconnect", xml, f, as.character(name), PACKAGE = "RGtkGlade"))
}

gladeXMLDefaultConnect <-
function(cb, obj, signalName, signalData, connectObj, after)
{
  require(RGtk)
  class(obj) <- "GtkObject"
  if(signalData == "")
    data = NULL
  else if(exists(signalData)) {
    data <- get(signalData)
  } else {
    data <- try(parse(text = signalData))
    if(inherits(data, "try-error"))
      data <- signalData
    else {
       # Need to sink here.
      data <- try(eval(data))
      if(inherits(data, "try-error"))
        data <- signalData
    }
  }

  if(exists(cb))
    cb <- get(cb)
  else
    cb <- parse(text = cb)

  obj$AddCallback(signalName, cb, data = data, object = FALSE)
}

