#include <gtk/gtk.h>
#include <glade/glade.h>

#include <stdio.h>

int main(int argc, char *argv[]) {
    GladeXML *xml;
    GtkWidget *dlg, *win, *w;
    char *fileName = "gnome-interface.glade";
    char *widgetName = NULL;

    gtk_init(&argc, &argv);
    glade_init();

    if(argc > 1)
	 fileName = argv[1];
    if(argc > 2)
	 widgetName = argv[2];

    /* load the interface */
    fprintf(stderr, "Loading file %s \n", fileName);fflush(stderr);
    xml = glade_xml_new(fileName, NULL);

    /* connect the signals in the interface */
    glade_xml_signal_autoconnect(xml);

    if(widgetName) {
      w = glade_xml_get_widget(xml, widgetName);
      fprintf(stderr, "Widget %s: %p\n", widgetName, w);fflush(stderr);

      win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
      gtk_container_add(GTK_CONTAINER(win), w);

      gtk_widget_show_all(win);
    }

    /* start the event loop */
    gtk_main();
    return 0;
}
