\name{gladeXMLDefaultConnect}
\alias{gladeXMLDefaultConnect}
\title{Default mechanism to register Glade callbacks}
\description{
  This function is used with \code{\link{gladeXMLAutoconnect}}
  to register the callback specifications for a Glade interface.
}
\usage{
gladeXMLDefaultConnect(cb, obj, signalName, signalData, connectObj, after)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{cb}{the callback string from Glade
    which is to be invoked when the signal is emitted.
    This is interpreted
    as the name of a function or an
    expression which should evaluate to
    a function or expression.
    Essentially, in this function, this is evaluated
    as an S expression when the signal is being registered.
  }
  \item{obj}{the Gtk object on which to register the callback}
  \item{signalName}{the name of the Gtk signal for which to register the
   handler, e.g. "clicked", "value-changed"}
 \item{signalData}{a string giving any additional S values that are
  to be passed to the callback function when it is invoked in response
  to a signal. This corresponds to the \code{data} argument
  in the \code{\link[RGtk]{gtkObjectAddCallback}} function.
  In this function, we try to evaluate this as an expression
  and use the result as the data value.
  If the evaluation fails, we use the string as the data itself.
  If this is the empty string, we ignore it and pass \code{NULL} as the data argument.}
\item{connectObj}{a logical value indicating whether the callback
  is to be registered with the data as the last argument or the first.
  Specifically, this value can be used directly as the value of the
  \code{object} argument in the call to \code{\link[RGtk]{gtkObjectAddCallback}}}
\item{after}{a logical value controlling how the callback is to be
  invoked. There is no counterpart to this yet in
  \code{\link[RGtk]{gtkObjectAddCallback}}.
 }
}
\value{
 This is expected to call \code{\link[RGtk]{gtkObjectAddCallback}}
}

\references{
  Glade - \url{http://glade.pn.org}
  libglade -  \url{http://developer.gnome.org/doc/API/libglade/libglade.html}
  RGtk  
}
\author{Duncan Temple Lang <duncan@research.bell-labs.com>}
\seealso{
  \code{\link{gladeXMLDefaultConnect}}
}

\examples{
}
\keyword{interface}

