#include "RGtk.h"
#include "RGtkGlade.h"
#include <Rdefines.h>

#define COPY_TO_USER_STRING(x) mkChar(x)

static void
R_autoconnect(const gchar *handler_name,
	      GtkObject *object,
	      const gchar *signal_name,
	      const gchar *signal_data,
	      GtkObject *connect_object,
	      gboolean after,
	      SEXP fun)
{
  SEXP expr, e, str;

  if(!handler_name)
     return;

  PROTECT(e = expr = allocVector(LANGSXP, 7));

  SETCAR(e, fun);

  e = CDR(e);
  SETCAR(e, str = allocVector(STRSXP, 1)); 
  SET_STRING_ELT(str, 0, COPY_TO_USER_STRING(handler_name));

  e = CDR(e);
  SETCAR(e, toRPointer(object, "GtkObject"));

  e = CDR(e);
  SETCAR(e, str = allocVector(STRSXP, 1)); 
  if(signal_name)
    SET_STRING_ELT(str, 0, COPY_TO_USER_STRING(signal_name));

  e = CDR(e);
  SETCAR(e, str = allocVector(STRSXP, 1)); 
  if(signal_data)
    SET_STRING_ELT(str, 0, COPY_TO_USER_STRING(signal_data));


  e = CDR(e);
/*  SETCAR(e, toRPointer(connect_object, "GtkObject")); */
  SETCAR(e, str = allocVector(LGLSXP, 1));
  LOGICAL_DATA(str)[0] = connect_object != NULL ? TRUE : FALSE;


  e = CDR(e);
  SETCAR(e, str = allocVector(LGLSXP, 1));
  LOGICAL_DATA(str)[0] = after;

  Rf_eval(expr, R_GlobalEnv);

  UNPROTECT(1);
}

USER_OBJECT_
R_glade_xml_signal_autoconnect(USER_OBJECT_ xmlGlade, USER_OBJECT_ func, USER_OBJECT_ handlerName)
{
  GladeXML * xml = ( GladeXML * ) getPtrValue( xmlGlade);
  USER_OBJECT_ ans = NULL_USER_OBJECT;

  if(GET_LENGTH(handlerName)) {
     int i, n = GET_LENGTH(handlerName);
     for(i = 0; i < n; i++) {
       glade_xml_signal_connect_full(xml, CHAR_DEREF(STRING_ELT(handlerName, i)), (GladeXMLConnectFunc) R_autoconnect, func);
     }
  } else
    glade_xml_signal_autoconnect_full(xml, (GladeXMLConnectFunc) R_autoconnect, func);

  return(ans);
}
